diff --git a/libinterp/octave-value/ov-re-diag.cc b/libinterp/octave-value/ov-re-diag.cc
index 5c7cd2f..3a3aee5 100644
--- a/libinterp/octave-value/ov-re-diag.cc
+++ b/libinterp/octave-value/ov-re-diag.cc
@@ -92,31 +92,41 @@ octave_diag_matrix::do_index_op (const octave_value_list& idx,
   // vectors.
   if (! resize_ok && idx.length () == 2 && matrix.is_multiple_of_identity (1))
     {
-      idx_vector idx0 = idx(0).index_vector ();
-      idx_vector idx1 = idx(1).index_vector ();
-
-      if (! error_state)
+      int k = 0;        // index we're accesing when index_vector throws
+      try
         {
-          bool left = idx0.is_permutation (matrix.rows ());
-          bool right = idx1.is_permutation (matrix.cols ());
+          idx_vector idx0 = idx(0).index_vector ();
+          k = 1;
+          idx_vector idx1 = idx(1).index_vector ();
 
-          if (left && right)
+          if (! error_state)
             {
-              if (idx0.is_colon ()) left = false;
-              if (idx1.is_colon ()) right = false;
+              bool left = idx0.is_permutation (matrix.rows ());
+              bool right = idx1.is_permutation (matrix.cols ());
+
               if (left && right)
-                retval = PermMatrix (idx0, false) * PermMatrix (idx1, true);
-              else if (left)
-                retval = PermMatrix (idx0, false);
-              else if (right)
-                retval = PermMatrix (idx1, true);
-              else
                 {
-                  retval = this;
-                  this->count++;
+                  if (idx0.is_colon ()) left = false;
+                  if (idx1.is_colon ()) right = false;
+                  if (left && right)
+                    retval = PermMatrix (idx0, false) * PermMatrix (idx1, true);
+                  else if (left)
+                    retval = PermMatrix (idx0, false);
+                  else if (right)
+                    retval = PermMatrix (idx1, true);
+                  else
+                    {
+                      retval = this;
+                      this->count++;
+                    }
                 }
             }
         }
+      catch (idx_except& e)
+        {
+          e.set_pos_if_unset (2, k+1);
+          throw;   // caught in pt-idx.cc / pt-assign.cc to get var name
+        }
     }
 
   // if error_state is set, we've already griped.
diff --git a/libinterp/octave-value/ov-re-sparse.cc b/libinterp/octave-value/ov-re-sparse.cc
index aba5796..46e4356 100644
--- a/libinterp/octave-value/ov-re-sparse.cc
+++ b/libinterp/octave-value/ov-re-sparse.cc
@@ -61,8 +61,8 @@ octave_sparse_matrix::index_vector (bool /* require_integers */) const
     return idx_vector (array_value ());
   else
     {
-      std::string nm = type_name ();
-      error ("%s type invalid as index value", nm.c_str ());
+      std::string nm = "<" + type_name () + ">";
+      gripe_invalid_index (nm.c_str ());
       return idx_vector ();
     }
 }
diff --git a/libinterp/octave-value/ov-str-mat.cc b/libinterp/octave-value/ov-str-mat.cc
index 35d7e25..ea8f467 100644
--- a/libinterp/octave-value/ov-str-mat.cc
+++ b/libinterp/octave-value/ov-str-mat.cc
@@ -94,46 +94,60 @@ octave_char_matrix_str::do_index_op_internal (const octave_value_list& idx,
 
   octave_idx_type len = idx.length ();
 
-  switch (len)
+    // If we catch an indexing error in  index_vector(),  we flag an error in
+    // index  k.  Ensure it is the right value befor each idx_vector() call.
+    // Same variable as used in for() loop in default: case.
+  octave_idx_type k = 0;
+
+  try
+    {
+      switch (len)
+        {
+        case 0:
+          retval = octave_value (matrix, type);
+          break;
+
+        case 1:
+          {
+            idx_vector i = idx (0).index_vector ();
+
+            if (! error_state)
+              retval = octave_value (charNDArray (matrix.index (i, resize_ok)),
+                                     type);
+          }
+          break;
+
+        case 2:
+          {
+            idx_vector i = idx (0).index_vector ();
+            k = 1;
+            idx_vector j = idx (1).index_vector ();
+
+            if (! error_state)
+              retval = octave_value (charNDArray (matrix.index (i, j, resize_ok)),
+                                     type);
+          }
+          break;
+
+        default:
+          {
+            Array<idx_vector> idx_vec (dim_vector (len, 1));
+
+            for (k = 0; k < len; k++)
+              idx_vec(k) = idx(k).index_vector ();
+
+            if (! error_state)
+              retval =
+                octave_value (charNDArray (matrix.index (idx_vec, resize_ok)),
+                              type);
+          }
+          break;
+        }
+    }
+  catch (idx_except& e)
     {
-    case 0:
-      retval = octave_value (matrix, type);
-      break;
-
-    case 1:
-      {
-        idx_vector i = idx (0).index_vector ();
-
-        if (! error_state)
-          retval = octave_value (charNDArray (matrix.index (i, resize_ok)),
-                                 type);
-      }
-      break;
-
-    case 2:
-      {
-        idx_vector i = idx (0).index_vector ();
-        idx_vector j = idx (1).index_vector ();
-
-        if (! error_state)
-          retval = octave_value (charNDArray (matrix.index (i, j, resize_ok)),
-                                 type);
-      }
-      break;
-
-    default:
-      {
-        Array<idx_vector> idx_vec (dim_vector (len, 1));
-
-        for (octave_idx_type i = 0; i < len; i++)
-          idx_vec(i) = idx(i).index_vector ();
-
-        if (! error_state)
-          retval =
-            octave_value (charNDArray (matrix.index (idx_vec, resize_ok)),
-                          type);
-      }
-      break;
+      e.set_pos_if_unset (len, k+1);
+      throw;   // caught in pt-idx.cc / pt-assign.cc, when var name known
     }
 
   return retval;
diff --git a/libinterp/octave-value/ov.cc b/libinterp/octave-value/ov.cc
index 69371fd..c12aae4 100644
--- a/libinterp/octave-value/ov.cc
+++ b/libinterp/octave-value/ov.cc
@@ -1496,6 +1496,11 @@ octave_value::assign (assign_op op, const octave_value& rhs)
               // Usually unnecessary, but may be needed (complex arrays).
               maybe_mutate ();
             }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, assign");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
           catch (octave_execution_exception)
             {
               gripe_library_execution_error ();
@@ -1997,6 +2002,11 @@ do_binary_op (octave_value::binary_op op,
             {
               retval = f (v1, v2);
             }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, do_binary_op 1");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
           catch (octave_execution_exception)
             {
               gripe_library_execution_error ();
@@ -2020,6 +2030,11 @@ do_binary_op (octave_value::binary_op op,
             {
               retval = f (*v1.rep, *v2.rep);
             }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, do_binary_op 2");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
           catch (octave_execution_exception)
             {
               gripe_library_execution_error ();
@@ -2148,6 +2163,12 @@ do_binary_op (octave_value::binary_op op,
                         {
                           retval = f (*tv1.rep, *tv2.rep);
                         }
+		      catch (idx_except& e)
+			{
+			  warning("internal error(?): unhandled index exception caught in ov, do_binary_op 3");
+                          (*current_liboctave_error_with_id_handler)
+                                                        (e.id(), e.err());
+			}
                       catch (octave_execution_exception)
                         {
                           gripe_library_execution_error ();
@@ -2256,6 +2277,11 @@ do_binary_op (octave_value::compound_binary_op op,
             {
               retval = f (v1, v2);
             }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, do_binary_op 4");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
           catch (octave_execution_exception)
             {
               gripe_library_execution_error ();
@@ -2275,6 +2301,11 @@ do_binary_op (octave_value::compound_binary_op op,
             {
               retval = f (*v1.rep, *v2.rep);
             }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, do_binary_op 5");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
           catch (octave_execution_exception)
             {
               gripe_library_execution_error ();
@@ -2321,6 +2352,11 @@ do_cat_op (const octave_value& v1, const octave_value& v2,
         {
           retval = f (*v1.rep, *v2.rep, ra_idx);
         }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, do_cat_op");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
       catch (octave_execution_exception)
         {
           gripe_library_execution_error ();
@@ -2526,6 +2562,11 @@ do_unary_op (octave_value::unary_op op, const octave_value& v)
             {
               retval = f (v);
             }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, do_unary_op 1");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
           catch (octave_execution_exception)
             {
               gripe_library_execution_error ();
@@ -2549,6 +2590,11 @@ do_unary_op (octave_value::unary_op op, const octave_value& v)
             {
               retval = f (*v.rep);
             }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, do_unary_op 2");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
           catch (octave_execution_exception)
             {
               gripe_library_execution_error ();
@@ -2619,6 +2665,11 @@ octave_value::do_non_const_unary_op (unary_op op)
             {
               f (*rep);
             }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, non_const_unary_op 1");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
           catch (octave_execution_exception)
             {
               gripe_library_execution_error ();
@@ -2647,6 +2698,11 @@ octave_value::do_non_const_unary_op (unary_op op)
                         {
                           f (*rep);
                         }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, non_const_unary_op 2");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
                       catch (octave_execution_exception)
                         {
                           gripe_library_execution_error ();
@@ -2695,6 +2751,11 @@ octave_value::do_non_const_unary_op (unary_op op)
             {
               f (*rep);
             }
+	  catch (idx_except& e)
+	    {
+	      warning("internal error(?): unhandled index exception caught in ov, non_const_unary_op 3");
+              (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+	    }
           catch (octave_execution_exception)
             {
               gripe_library_execution_error ();
diff --git a/libinterp/parse-tree/pt-assign.cc b/libinterp/parse-tree/pt-assign.cc
index a259001..42533f9 100644
--- a/libinterp/parse-tree/pt-assign.cc
+++ b/libinterp/parse-tree/pt-assign.cc
@@ -106,41 +106,49 @@ tree_simple_assignment::rvalue1 (int)
                     }
                 }
 
-              octave_lvalue ult = lhs->lvalue ();
-
-              if (ult.numel () != 1)
-                gripe_nonbraced_cs_list_assignment ();
-
-              if (! error_state)
+              try
                 {
-                  ult.assign (etype, rhs_val);
+                  octave_lvalue ult = lhs->lvalue ();
+
+                  if (ult.numel () != 1)
+                    gripe_nonbraced_cs_list_assignment ();
 
                   if (! error_state)
                     {
-                      if (etype == octave_value::op_asn_eq)
-                        retval = rhs_val;
-                      else
-                        retval = ult.value ();
+                      ult.assign (etype, rhs_val);
 
-                      if (print_result ()
-                          && tree_evaluator::statement_printing_enabled ())
+                      if (! error_state)
                         {
-                          // We clear any index here so that we can
-                          // get the new value of the referenced
-                          // object below, instead of the indexed
-                          // value (which should be the same as the
-                          // right hand side value).
-
-                          ult.clear_index ();
-
-                          octave_value lhs_val = ult.value ();
-
-                          if (! error_state)
-                            lhs_val.print_with_name (octave_stdout,
-                                                     lhs->name ());
+                          if (etype == octave_value::op_asn_eq)
+                            retval = rhs_val;
+                          else
+                            retval = ult.value ();
+
+                          if (print_result ()
+                              && tree_evaluator::statement_printing_enabled ())
+                            {
+                              // We clear any index here so that we can
+                              // get the new value of the referenced
+                              // object below, instead of the indexed
+                              // value (which should be the same as the
+                              // right hand side value).
+
+                              ult.clear_index ();
+
+                              octave_value lhs_val = ult.value ();
+
+                              if (! error_state)
+                                lhs_val.print_with_name (octave_stdout,
+                                                         lhs->name ());
+                            }
                         }
                     }
                 }
+              catch (idx_except& e)
+                {	// problems with range, invalid index type etc.
+                  e.set_var (lhs->name ());
+                  (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+                }
             }
         }
     }
diff --git a/libinterp/parse-tree/pt-eval.cc b/libinterp/parse-tree/pt-eval.cc
index 61846aa..5a16202 100644
--- a/libinterp/parse-tree/pt-eval.cc
+++ b/libinterp/parse-tree/pt-eval.cc
@@ -751,6 +751,12 @@ tree_evaluator::visit_statement (tree_statement& stmt)
               //                result_values(0) = tmp_result;
             }
         }
+      catch (idx_except& e)	// temporary code.  Remove when confident
+        {			// all exceptions are caught.
+				// (Will fall through to next case anyway.)
+	  warning("error: unhandled index exception in pt-eval");
+	  (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+        }
       catch (octave_execution_exception)
         {
           gripe_library_execution_error ();
diff --git a/libinterp/parse-tree/pt-id.h b/libinterp/parse-tree/pt-id.h
index 20eb997..c173262 100644
--- a/libinterp/parse-tree/pt-id.h
+++ b/libinterp/parse-tree/pt-id.h
@@ -66,7 +66,7 @@ public:
 
   bool is_defined (void) { return sym->is_defined (); }
 
-  virtual bool is_variable (void) { return sym->is_variable (); }
+  virtual bool is_variable (void) const { return sym->is_variable (); }
 
   virtual bool is_black_hole (void) { return false; }
 
@@ -152,7 +152,7 @@ public:
 
   std::string name (void) const { return "~"; }
 
-  bool is_variable (void) { return false; }
+  bool is_variable (void) const { return false; }
 
   bool is_black_hole (void) { return true; }
 
diff --git a/libinterp/parse-tree/pt-idx.cc b/libinterp/parse-tree/pt-idx.cc
index 212e276..e04bdac 100644
--- a/libinterp/parse-tree/pt-idx.cc
+++ b/libinterp/parse-tree/pt-idx.cc
@@ -284,6 +284,18 @@ tree_index_expression::rvalue (int nargout)
   return tree_index_expression::rvalue (nargout, 0);
 }
 
+// Final step of processing an indexing error.  Add the name of the
+// variable being indexed, if any, then issue an error.
+//    (Will this also be needed by  pt-lvalue,  which calls subsref?)
+void
+final_index_error (idx_except& e, const tree_expression *expr)
+{
+  if (expr->is_identifier () &&
+            dynamic_cast<const tree_identifier *> (expr)->is_variable ())
+    e.set_var (expr->name ());
+  (*current_liboctave_error_with_id_handler) (e.id (), e.err ());
+}
+
 octave_value_list
 tree_index_expression::rvalue (int nargout,
                                const std::list<octave_lvalue> *lvalue_list)
@@ -353,7 +365,7 @@ tree_index_expression::rvalue (int nargout,
 
               if (force_split || (al && al->has_magic_end ()))
                 {
-                  // We have an expression like
+                  // (we have force_split, or) we have an expression like
                   //
                   //   x{end}.a(end)
                   //
@@ -363,38 +375,45 @@ tree_index_expression::rvalue (int nargout,
                   // that argument list so we can pass the appropriate
                   // value to the built-in end function.
 
-                  octave_value_list tmp_list
-                    = tmp.subsref (type.substr (tmpi, i - tmpi), idx, nargout);
-
-                  tmp = tmp_list.length () ? tmp_list(0) : octave_value ();
-                  tmpi = i;
-                  idx.clear ();
+                  try
+                    {
+                      octave_value_list tmp_list
+                        =tmp.subsref (type.substr (tmpi, i-tmpi), idx, nargout);
 
-                  if (tmp.is_cs_list ())
-                    gripe_indexed_cs_list ();
+                      tmp = tmp_list.length () ? tmp_list(0) : octave_value ();
+                      tmpi = i;
+                      idx.clear ();
 
-                  if (error_state)
-                    break;
+                      if (tmp.is_cs_list ())
+                        gripe_indexed_cs_list ();
 
-                  if (tmp.is_function ())
-                    {
-                      octave_function *fcn = tmp.function_value (true);
+                      if (error_state)
+                        break;
 
-                      if (fcn && ! fcn->is_postfix_index_handled (type[i]))
+                      if (tmp.is_function ())
                         {
-                          octave_value_list empty_args;
+                          octave_function *fcn = tmp.function_value (true);
 
-                          tmp_list = tmp.do_multi_index_op (1, empty_args);
-                          tmp = (tmp_list.length ()
-                                 ? tmp_list(0) : octave_value ());
+                          if (fcn && ! fcn->is_postfix_index_handled (type[i]))
+                            {
+                              octave_value_list empty_args;
 
-                          if (tmp.is_cs_list ())
-                            gripe_indexed_cs_list ();
+                              tmp_list = tmp.do_multi_index_op (1, empty_args);
+                              tmp = (tmp_list.length ()
+                                     ? tmp_list(0) : octave_value ());
 
-                          if (error_state)
-                            break;
+                              if (tmp.is_cs_list ())
+                                gripe_indexed_cs_list ();
+
+                              if (error_state)
+                                break;
+                            }
                         }
                     }
+                  catch (idx_except& e)  // problems with index range, type etc.
+                    {
+                      final_index_error (e, expr);
+                    }
                 }
             }
 
@@ -433,8 +452,15 @@ tree_index_expression::rvalue (int nargout,
 
       if (! error_state)
         {
-          retval = tmp.subsref (type.substr (tmpi, n - tmpi), idx, nargout,
-                                lvalue_list);
+	  try
+	    {
+	      retval = tmp.subsref (type.substr (tmpi, n - tmpi), idx, nargout,
+				    lvalue_list);
+	    }
+	  catch (idx_except& e)	// problems with range, invalid index type etc.
+	    {
+	      final_index_error (e, expr);
+	    }
 
           octave_value val = retval.length () ? retval(0) : octave_value ();
 
@@ -500,7 +526,14 @@ tree_index_expression::lvalue (void)
             gripe_indexed_cs_list ();
           else if (tmpi < i)
             {
-              tmp = tmp.subsref (type.substr (tmpi, i - tmpi), tmpidx, true);
+              try
+                {
+                  tmp = tmp.subsref (type.substr (tmpi, i-tmpi), tmpidx, true);
+                }
+              catch (idx_except& e)  // problems with range, invalid type etc.
+                {
+                  final_index_error (e, expr);
+                }
               tmpidx.clear ();
             }
 
diff --git a/liboctave/array/Array-util.cc b/liboctave/array/Array-util.cc
index 26ab018..2775d3a 100644
--- a/liboctave/array/Array-util.cc
+++ b/liboctave/array/Array-util.cc
@@ -178,9 +178,9 @@ octave_idx_type
 compute_index (octave_idx_type n, const dim_vector& dims)
 {
   if (n < 0)
-    gripe_invalid_index ();
+    gripe_invalid_index (n, 1, 1);
   if (n >= dims.numel ())
-    gripe_index_out_of_range (1, 1, n+1, dims.numel ());
+    gripe_index_out_of_range (1, 1, n+1, dims.numel (), dims);
 
   return n;
 }
@@ -188,12 +188,14 @@ compute_index (octave_idx_type n, const dim_vector& dims)
 octave_idx_type
 compute_index (octave_idx_type i, octave_idx_type j, const dim_vector& dims)
 {
-  if (i < 0 || j < 0)
-    gripe_invalid_index ();
+  if (i < 0)
+    gripe_invalid_index (i, 2, 1);
+  else if (j < 0)
+    gripe_invalid_index (j, 2, 2);
   if (i >= dims(0))
-    gripe_index_out_of_range (2, 1, i+1, dims(0));
+    gripe_index_out_of_range (2, 1, i+1, dims(0), dims);
   if (j >= dims.numel (1))
-    gripe_index_out_of_range (2, 2, j+1, dims.numel (1));
+    gripe_index_out_of_range (2, 2, j+1, dims.numel (1), dims);
 
   return j*dims(0) + i;
 }
@@ -202,14 +204,18 @@ octave_idx_type
 compute_index (octave_idx_type i, octave_idx_type j, octave_idx_type k,
                const dim_vector& dims)
 {
-  if (i < 0 || j < 0 || k < 0)
-    gripe_invalid_index ();
+  if (i < 0)
+    gripe_invalid_index (i, 3, 1);
+  else if (j < 0)
+    gripe_invalid_index (j, 3, 2);
+  else if (k < 0)
+    gripe_invalid_index (k, 3, 3);
   if (i >= dims(0))
-    gripe_index_out_of_range (3, 1, i+1, dims(0));
+    gripe_index_out_of_range (3, 1, i+1, dims(0), dims);
   if (j >= dims(1))
-    gripe_index_out_of_range (3, 2, j+1, dims(1));
+    gripe_index_out_of_range (3, 2, j+1, dims(1), dims);
   if (k >= dims.numel (2))
-    gripe_index_out_of_range (3, 3, k+1, dims.numel (2));
+    gripe_index_out_of_range (3, 3, k+1, dims.numel (2), dims);
 
   return (k*dims(1) + j)*dims(0) + i;
 }
@@ -222,9 +228,9 @@ compute_index (const Array<octave_idx_type>& ra_idx, const dim_vector& dims)
   for (int d = 0; d < nd; d++)
     {
       if (ra_idx(d) < 0)
-        gripe_invalid_index ();
+        gripe_invalid_index (ra_idx(d), nd, d+1);
       if (ra_idx(d) >= dv(d))
-        gripe_index_out_of_range (nd, d+1, ra_idx(d)+1, dv(d));
+        gripe_index_out_of_range (nd, d+1, ra_idx(d)+1, dv(d), dims);
     }
 
   return dv.compute_index (ra_idx.data ());
@@ -540,18 +546,29 @@ sub2ind (const dim_vector& dv, const Array<idx_vector>& idxa)
 
       for (octave_idx_type i = 0; i < len; i++)
         {
-          idx_vector idx = idxa(i);
-          octave_idx_type n = dvx(i);
+          try
+            {
+              idx_vector idx = idxa(i);
+              octave_idx_type n = dvx(i);
 
-          all_ranges = all_ranges && idx.is_range ();
-          if (clen < 0)
-            clen = idx.length (n);
-          else if (clen != idx.length (n))
-            current_liboctave_error_handler ("sub2ind: lengths of indices must match");
+              all_ranges = all_ranges && idx.is_range ();
+              if (clen < 0)
+                clen = idx.length (n);
+              else if (clen != idx.length (n))
+                current_liboctave_error_handler ("sub2ind: lengths of indices must match");
 
-          if (idx.extent (n) > n)
-            current_liboctave_error_handler ("sub2ind: index out of range");
+              if (idx.extent (n) > n)
+                  gripe_index_out_of_range (len, i+1, idx.extent (n), n);
+            }
+          catch (idx_except& e)
+            {
+	      e.set_pos_if_unset (len, i+1);
+	      e.set_var ("");		// no particular variable
+	      (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+            }
         }
+      // idxa known to be valid. Shouldn't need to catch idx_except below here.
+
 
       if (len == 1)
         retval = idxa(0);
@@ -561,7 +578,7 @@ sub2ind (const dim_vector& dv, const Array<idx_vector>& idxa)
           octave_idx_type idx = idxa(len-1)(0);
           for (octave_idx_type i = len - 2; i >= 0; i--)
             idx = idx * dvx(i) + idxa(i)(0);
-          retval = idx_vector (idx);
+            retval = idx_vector (idx);
         }
       else if (all_ranges && clen != 0)
         {
@@ -575,7 +592,7 @@ sub2ind (const dim_vector& dv, const Array<idx_vector>& idxa)
               start = start * dvx(i) + xstart;
               step = step * dvx(i) + xstep;
             }
-          retval = idx_vector::make_range (start, step, clen);
+	  retval = idx_vector::make_range (start, step, clen);
         }
       else
         {
@@ -590,7 +607,7 @@ sub2ind (const dim_vector& dv, const Array<idx_vector>& idxa)
                 idxa(i).copy_data (idx_vec);
             }
 
-          retval = idx_vector (idx);
+	  retval = idx_vector (idx);
         }
     }
   else
diff --git a/liboctave/array/Array.cc b/liboctave/array/Array.cc
index 882ba59..d5713c1 100644
--- a/liboctave/array/Array.cc
+++ b/liboctave/array/Array.cc
@@ -190,9 +190,9 @@ Array<T>::checkelem (octave_idx_type n)
 {
   // Do checks directly to avoid recomputing slice_len.
   if (n < 0)
-    gripe_invalid_index ();
+    gripe_invalid_index (n);
   if (n >= slice_len)
-    gripe_index_out_of_range (1, 1, n+1, slice_len);
+    gripe_index_out_of_range (1, 1, n+1, slice_len, dimensions);
 
   return elem (n);
 }
@@ -224,9 +224,9 @@ Array<T>::checkelem (octave_idx_type n) const
 {
   // Do checks directly to avoid recomputing slice_len.
   if (n < 0)
-    gripe_invalid_index ();
+    gripe_invalid_index (n);
   if (n >= slice_len)
-    gripe_index_out_of_range (1, 1, n+1, slice_len);
+    gripe_index_out_of_range (1, 1, n+1, slice_len, dimensions);
 
   return elem (n);
 }
@@ -260,7 +260,7 @@ Array<T>::column (octave_idx_type k) const
   octave_idx_type r = dimensions(0);
 #ifdef BOUNDS_CHECKING
   if (k < 0 || k > dimensions.numel (1))
-    gripe_index_out_of_range (2, 2, k+1, dimensions.numel (1));
+    gripe_index_out_of_range (2, 2, k+1, dimensions.numel (1), dimensions);
 #endif
 
   return Array<T> (*this, dim_vector (r, 1), k*r, k*r + r);
@@ -275,7 +275,7 @@ Array<T>::page (octave_idx_type k) const
   octave_idx_type p = r*c;
 #ifdef BOUNDS_CHECKING
   if (k < 0 || k > dimensions.numel (2))
-    gripe_index_out_of_range (3, 3, k+1, dimensions.numel (2));
+    gripe_index_out_of_range (3, 3, k+1, dimensions.numel (2), dimensions);
 #endif
 
   return Array<T> (*this, dim_vector (r, c), k*p, k*p + p);
@@ -287,9 +287,9 @@ Array<T>::linear_slice (octave_idx_type lo, octave_idx_type up) const
 {
 #ifdef BOUNDS_CHECKING
   if (lo < 0)
-    gripe_index_out_of_range (1, 1, lo+1, numel ());
+    gripe_index_out_of_range (1, 1, lo+1, numel (), dimensions);
   if (up > numel ())
-    gripe_index_out_of_range (1, 1, up, numel ());
+    gripe_index_out_of_range (1, 1, up, numel (), dimensions);
 #endif
   if (up < lo) up = lo;
   return Array<T> (*this, dim_vector (up - lo, 1), lo, up);
@@ -726,7 +726,7 @@ Array<T>::index (const idx_vector& i) const
   else
     {
       if (i.extent (n) != n)
-        gripe_index_out_of_range (1, 1, i.extent (n), n); // throws
+        gripe_index_out_of_range (1, 1, i.extent (n), n, dimensions); // throws
 
       // FIXME: this is the only place where orig_dimensions are used.
       dim_vector rd = i.orig_dimensions ();
@@ -793,9 +793,9 @@ Array<T>::index (const idx_vector& i, const idx_vector& j) const
   else
     {
       if (i.extent (r) != r)
-        gripe_index_out_of_range (2, 1, i.extent (r), r); // throws
+        gripe_index_out_of_range (2, 1, i.extent (r), r, dimensions); // throws
       if (j.extent (c) != c)
-        gripe_index_out_of_range (2, 2, j.extent (c), c); // throws
+        gripe_index_out_of_range (2, 2, j.extent (c), c, dimensions); // throws
 
       octave_idx_type n = numel ();
       octave_idx_type il = i.length (r);
@@ -855,7 +855,7 @@ Array<T>::index (const Array<idx_vector>& ia) const
       for (int i = 0; i < ial; i++)
         {
           if (ia(i).extent (dv(i)) != dv(i))
-            gripe_index_out_of_range (ial, i+1, ia(i).extent (dv(i)), dv(i)); // throws
+            gripe_index_out_of_range (ial, i+1, ia(i).extent (dv(i)), dv(i), dimensions); // throws
 
           all_colons = all_colons && ia(i).is_colon ();
         }
@@ -1180,7 +1180,7 @@ Array<T>::assign (const idx_vector& i, const Array<T>& rhs, const T& rfv)
         }
     }
   else
-    gripe_invalid_assignment_size ();
+    gripe_nonconformant ("=", dim_vector(i.length(n),1), rhs.dims());
 }
 
 template <class T>
@@ -1282,7 +1282,7 @@ Array<T>::assign (const idx_vector& i, const idx_vector& j,
         }
     }
   else
-    gripe_assignment_dimension_mismatch ();
+    gripe_nonconformant ("=", il, jl, rhs.dim1(), rhs.dim2());
 }
 
 template <class T>
@@ -1384,10 +1384,18 @@ Array<T>::assign (const Array<idx_vector>& ia,
             }
         }
       else
-        gripe_assignment_dimension_mismatch ();
+	gripe_nonconformant  ("=", dv, rhdv);
     }
 }
 
+/*
+%!shared a
+%! a = [1 2; 3 4];
+%!error <op1 is 1x2, op2 is 1x3> a(1,:) = [1 2 3]
+%!error <op1 is 2x1, op2 is 1x3> a(:,1) = [1 2 3]
+%!error <op1 is 2x2, op2 is 2x1> a(1:2,2:3) = [1;2]
+*/
+
 template <class T>
 void
 Array<T>::delete_elements (const idx_vector& i)
diff --git a/liboctave/array/DiagArray2.cc b/liboctave/array/DiagArray2.cc
index 78c794a..eb404ba 100644
--- a/liboctave/array/DiagArray2.cc
+++ b/liboctave/array/DiagArray2.cc
@@ -126,13 +126,13 @@ DiagArray2<T>::check_idx (octave_idx_type r, octave_idx_type c) const
 
   if (r < 0 || r >= dim1 ())
     {
-      gripe_index_out_of_range (2, 1, r+1, dim1 ());
+      gripe_index_out_of_range (2, 1, r+1, dim1 (), dims ());
       ok = false;
     }
 
   if (c < 0 || c >= dim2 ())
     {
-      gripe_index_out_of_range (2, 2, c+1, dim2 ());
+      gripe_index_out_of_range (2, 2, c+1, dim2 (), dims ());
       ok = false;
     }
 
